<?

// Tell the system we are in processor mode      :
$processor = 1;

// Set some initital variables
$processorVersion = "2.02";

// Includes
include "../conf/conf.php";
include "./processor.php";

// Load appropriate modules
recursiveModuleLoad();

// Simulate login to console
$login = new mySession("processor");

// Set Script TIMEOUT Value
set_time_limit(2000);

// Variable Initilization
$ops = new myOps();
$ops->loadOps();

// Away we go!
processLoop();

function processLoop() {
	global $ops, $processorVersion;

    $start = date("U");

	echo "\n";
    echo "----------------------------------------------------\n";
	echo ":: " . $ops->getOpsVar("text_misc_" . $ops->getOpsVar("site_system")) . "\n";
	echo ":: BPU: Background Processing Unit B v$processorVersion\n";
	echo ":: IDS: " . versionText() . "\n";
	echo ":: Last processing finished " . statusProcessorLastRunDiff("B") . " seconds ago.\n";
	echo "----------------------------------------------------\n\n";

	remoteVersionCheck();
	remoteBulletinCheck();
	permissionsCheck();

    // Community Communication
    communityBufferProcess();

    // CUT idsMain DOWN TO SIZE
	pruneIdsMain();
    // CUT idsTrack DOWN TO SIZE
	pruneIdsTrack();

    // Archive Processor
    if ($ops->getOpsVar("site_archiveEnabled") == 1) {
        archiveTableProcessor();
    }

	// IP to Hostname Lookups
	hostnameLookup();

	// OAD
	$oadProcess = oadProcess();

	$objStatus = new myStatus();
	$objStatus->loadStatus();
	$objStatus->setStatusVar("processorB_lastRun", date("U"));
    if ($oadProcess == 1) $objStatus->setStatusVar("oad_lastUpload", date("U"));
    if ($oadProcess == 1) $objStatus->totalOadUploadIncrement();
	$objStatus->totalProcessorRunIncrement("B");
    $objStatus->saveStatus();

    // Action Processor
    actionProcessor();

    // Scanner
    scanProcessor();

    // Signature System
    sigProcessor();

    // RALPH (miscellaneous entries here)
    ralphProcessor();

    // Mail Processor
    processMail();

    $end = date("U");
    $seconds = $end - $start;


    echo "\n";
    echo "----------------------------------------------------\n";
	echo ":: Complete - $seconds\n";
    echo "----------------------------------------------------\n";

	exit;
}

